*-------------------------------------------------------------------------
*
*-------------------------------------------------------------------------
#include io.hdr
#include string.hdr
#include heap.hdr
*-------------------------------------------------------------------------
VARDEF PRIVATE
   CHAR                 RCSid = "$Header:$"
ENDDEF

VARDEF
   CHAR(25)             strs[10] = "Baby", "Dood", "Clue", "Egg", "Abba",;
                                   "Bob" , "Skut", "Nogg", "Men", "Horm"
ENDDEF
*-------------------------------------------------------------------------
PROCEDURE charcpy PROTOTYPE
   PARAMETERS VALUE LONG dest, CHAR source

FUNCTION LONG newalloc PROTOTYPE
   PARAMETERS VALUE UINT mem_size
*-------------------------------------------------------------------------
FUNCTION INT strcmp
   PARAMETERS CHAR str1, CHAR str2

   if str1 > str2
      return 1
   endif

   if str1 < str2
      return -1
   endif

   return 0

ENDPRO
*-------------------------------------------------------------------------
FUNCTION LOGICAL print_string
   PARAMETERS CHAR string

   VARDEF
      LOGICAL        not_null
   ENDDEF

   if len( string ) > 0
      ? string
      not_null = &TRUE
   else
      not_null = &FALSE
   endif

   return not_null

ENDPRO
*-------------------------------------------------------------------------
PROCEDURE force_main

   VARDEF
      LONG           heap_header
      LONG           buffer
      INT            i
   ENDDEF

   scrn_dos()

   heap_header = heap_create( strcmp )
   ? "heap_create: ", heap_header
   if heap_header = 0
      quit
   endif

   ? "Building heap..."

   for i = 0 to 9
      buffer = alloc( len( strs[i] ) + 1 )
      charcpy( buffer, strs[i] )
      if .not. heap_insert( heap_header, buffer )
         ? "heap_insert() returned FALSE"
         exit
      endif
   next

   ? "Sorting array..."
   heap_sort( heap_header )

   ? "Applying print_string():"
   heap_apply( heap_header, print_string )

ENDPRO
*-- EOF: -----------------------------------------------------------------








